# happy.fxh

Lots of HLSL functions in a (somewhat) systematic and organised collection of header files.  I made these for use with my vvvv projects and contributions, but should be fairly usable with HLSL in general. 

Headers.txt - just links to the fxh files in best practice format for easy copy pasting in vvvv context

sbuffer.fxh - DX11 Structured Buffer Helpers

calc.fxh - Calculus functions & macros

noise.fxh - Noise basis functions & utlities

map.fxh - Handy mapping functions

transform.fxh - Transformation matrix functions

sdf.fxh - loads of signed distance fields & helpers.  Quite a lot are ported from hg_sdf GLSL lib by MERCURY (CC BY-NC 2016)  http://mercury.sexy/hg_sdf

raymarch.fxh - Raymarching related functions

uv.fxh - UV and texture mapping functions

color.fxh - Color space conversions

spline.fxh - Some cubic b-splines


To install everything via VPM: https://vvvvpm.github.io/#Happy.fxh To install manually just place in /packs folder.
For more frequent updates, bug fixes and issue reporting: https://github.com/everyoneishappy/happy.fxh

MIT License- feel free to use in your creative & commercial projects. If used in production a credit is very appreciated:

[Kyle McLean] / [http://everyoneishappy.com]

I’m also very happy if you are doing something interesting and want to employ me on a project basis.

